10  CLS:PRINT:PRINT:PRINT "          AHD-2 ... Applied Hydraulic Design Program "
15  PRINT:PRINT:CLOSE
16  '
17  ' Original program author: Dr. M. Dougal, Civil Engr., ISU
18  ' Converted from Fortran to Basic by Dr. R.G. Allen, Civil Engr., ISU:1/85
19  '                Circular Sections and specific force added 1/85.
20  '
21  PRINT " Enter the name of your data file to read or an  S  for screen input (E to end)"
25  INPUT FILE$:IF FILE$ = "E" THEN GOTO 2000
26  OPEN "SCRN:" FOR OUTPUT AS #2
27  PRINT:PRINT " Do you wish output to be routed to a" :PRINT "   (P) Printer and screen, or":PRINT "   (F) Output file and screen, or":PRINT "   (S) Screen only"
28  INPUT O$:IF O$="F" THEN 30 ELSE IF O$="P" THEN 29 ELSE IF O$<>"S" THEN 27 ELSE GOTO 35
29  OPEN "LPT1:" FOR OUTPUT AS #3:GOTO 35
30  PRINT:INPUT " Output file name ";OF$:OPEN OF$ FOR OUTPUT AS #3
35  IF FILE$ <> "S" THEN OPEN FILE$ FOR INPUT AS #1
40  IF FILE$ <> "S" THEN INPUT #1,ICALC,ID$:GOTO 150
50  PRINT " Code        Type of Problems Solved":PRINT "(ICALC)"
60  PRINT "  1    Specific energy curve data and critical depth, for given Q"
70  PRINT "  2    Normal depth and S-Q curve data up to Normal Depth for given Q"
80  PRINT "  3    Both 1 and 2 solved in one run
90  PRINT "  4    S-Q curve computed for given range of depths"
100  PRINT "  5    Discharge and critical depth computed for given normal depth"
110  PRINT "  6    Water surface profile computed for given discharge, starting"
120  PRINT "        depth and desired end depth (Direct Step Method)"
130  PRINT:PRINT:INPUT " Enter the desired ICALC value (1-6) ",ICALC
140  PRINT:INPUT " Problem Title ",ID$
150  B=0:Z=0:RCN=0:SL=0:QD=0:DIN=0:DELD1=0:DFIN=0:DST=0:DELD2=0:STAIN=0:ELEVIN=0
152  IF ICALC =0 THEN GOTO 2000
155  IF FILE$ <> "S" THEN INPUT #1,JTYP,B,Z,RCN,SL,QD,DIN,DELD1,DFIN,DST,DELD2,STAIN,ELEVIN:GOTO 300
160  PRINT "Enter 1 for a uniform, trapezoidal or rectangular channel"
162  PRINT "      2 for a depressed culvert invert "
163  PRINT "   or 3 for a circular cross-section":INPUT JTYP
170  IF JTYP < 3 THEN INPUT "Enter the bottom width of the channel in feet (B) ",B
172  IF JTYP = 3 THEN INPUT "Enter the diameter of circular channel in feet (B) ",B
180  IF JTYP < 3 THEN INPUT "Enter the sideslope, horiz. to vert. (0 is vertical) (Z) ",Z
190  INPUT "Enter the value of Manning's roughness coefficient (RCN) ",RCN
200  INPUT "Enter the slope of invert of channel, ft/ft (positive,0,or neg) (SL) ",SL
210  INPUT "Enter the design discharge (0 if unknown for ICALC=4 or 5) (QD) ",QD
220  INPUT "Enter the initial depth to begin calculations (ICALC=1-5) (not 0) (DIN) ",DIN
230  PRINT "Enter the depth increment for computing successive values for S-Q ":INPUT " (i.e. 0.50 for mild and 0.25 for steep slopes) (DELD1) ",DELD1
240  PRINT "For ICALC =1-5 enter the max. depth for calculations (B if unknown)"
250  PRINT "For ICALC = 6  enter the depth at which water surface calculations stop":INPUT " (Usually normal depth) (DFIN) ",DFIN:IF ICALC < 6 THEN GOTO 295
260  INPUT "Enter the starting depth for ICALC = 6 (water surface profile) (DST) ",DST
270  INPUT "Enter the increment of depth (.25-.5 for mild, .1-.25 for steep (DELD2) ",DELD2
280  PRINT "Enter the initial stationing of the channel at the point where WSP computations"
290  INPUT "are to begin (at depth=DST).  Stationing should proceed upstream (STAIN) ",STAIN
295  INPUT "Enter the elevation of the channel invert at the initial station (ELEVIN) ",ELEVIN
300  '
305  IF B < 0 THEN 1900
310  IF B=0 THEN 320 ELSE GOTO 330
320  IF Z<0 THEN 1900
330  I=2:GOSUB 332:IF O$<>"S" THEN I=3:GOSUB 332
331  GOTO 475
332  PRINT #I,"           CE 472. APPLIED HYDRAULIC DESIGN (AHD-2)"
340  PRINT #I," SOLUTION OF NORMAL DEPTH, CRITICAL DEPTH, AND WATER SURFACE "
350  PRINT #I,"         PROFILE PROBLEMS IN SIMPLE CHANNEL SECTIONS"
360  PRINT#I,:PRINT #I, ID$
370  PRINT#I,:PRINT #I,
380  PRINT #I, "                       HYDRAULIC INPUT DATA"
385  PRINT #I," CHANNEL DATA"
390  PRINT #I,   "      B       Z       N      SL       STAIN     ELEVIN"
400  PRINT #I,USING "    ###.#   ###.#  ##.#### #.##### ######.## ######.##";B,Z,RCN,SL,STAIN,ELEVIN
410  PRINT#I,:PRINT#I,:PRINT#I," DISCHARGE AND DEPTH DATA":PRINT#I,
420  PRINT #I,   "     QD      DIN    DELD1   DFIN      DST     DELD2"
430  PRINT #I,USING "######.#  ###.##   ##.###  ###.##  ####.##  ####.##";QD,DIN,DELD1,DFIN,DST,DELD2
440  PRINT#I,:PRINT#I,
450  IF JTYP = 1 THEN PRINT #I, " DESIGN CHANNEL HAS A REGULAR CHANNEL SHAPE, RECTANGULAR OR TRAPEZOIDAL.":GOTO 470
460  IF JTYP = 2 THEN PRINT #I," DESIGN CHANNEL IS A DEPRESSED CULVERT INVERT SECTION OF I.H.C  ":GOTO 470
465  IF JTYP = 3 THEN PRINT #I,USING" DESIGN CHANNEL IS A CIRCULAR CROSS-SECTION OF DIAMETER ###.## feet";B
470  PRINT #I,:PRINT #I,USING " ICALC = ###";ICALC:PRINT #I,:RETURN
475  IF PN=1 THEN GOSUB 6330 'LINE PRINTER
480  HYP=Z*Z+1:ROOT1=SQR(HYP):IF SL <> 0 THEN GOTO 490 ELSE GOTO 500
490  SLHYP=SL*SL+1:ROOT3=SQR(SLHYP):GOTO 510
500  SLHYP=1:ROOT3=1
510  CFACT=1/ROOT3
520  '
530  ' PRINT OUT THE TYPE OF PROBLEM WHICH IS BEING SOLVED
540  '
550  IF ICALC=1 THEN GOTO 600 ELSE IF ICALC=2 THEN GOTO 610 ELSE IF ICALC=3 THEN GOTO 620
560  IF ICALC=4 THEN GOTO 630 ELSE IF ICALC=5 THEN GOTO 640 ELSE IF ICALC=6 THEN GOTO 650
600  PRINT "Calculate the Specific Energy Curve and Critical Depth for a Given Discharge":GOTO 720
610  PRINT "Calculate S-Q Curve Data and Normal Depth for a Given Discharge and Channel":GOTO 1060
620  PRINT "Calculate the Specific Energy Curve, Critical Depth, S-Q Curve and Normal Depth":GOTO 720
630  PRINT "Calculate S-Q Curve Data for Given Range of Depths and Channel Characteristics":GOTO 1300
640  PRINT "Calculate Design Discharge and Specific Energy Data and Critical Discharge":PRINT" for a given Normal Depth of Flow and Channel Characteristics":GOTO 1300
650  PRINT "Calculate a Water Surface Profile for an A,C,H,M, or S Curve for a Given ":PRINT "Discharge, Starting Depth and Channel Characteristics":GOTO 1600
720  '
730  '  Compute Specific Energy Curve and Critical Depth
740  '
750  IF QD <= 0 THEN 760 ELSE 770
760  PRINT USING "STOP  QD = ###.## CFS.  DIN = #### feet";QD,DIN:GOTO 1900
770  IF DIN <=0 THEN GOTO 760
780  I=2:GOSUB 782:IF O$ <>"S" THEN I=3:GOSUB 782
781  GOTO 820
782  PRINT#I,:PRINT#I,:PRINT #I," Computation of Specific Energy and Force Data and Critical Depth":PRINT#I,
790  PRINT #I,"Depth   Elev.   Area   Top   Mean  Veloc.  Vel.  Ratio  Spec.   Spec.   Elev.TH."
800  PRINT #I,"         W.S.         Width  Depth         Head  VH/DM  Head    Force     Line "
810  PRINT #I,"  ft.     ft.  sq.ft.  ft.    ft.    fps    ft.          ft.      lb.      ft. ":RETURN
820  D=DIN:DHOLD=DELD1/2
830  FOR N = 1 TO 100:GOSUB 5000:IF JTYP=3 AND D>B THEN 890
840  SH=D*CFACT+VH:ELWS=ELEVIN+D*CFACT:ELTH=ELEVIN+SH:SFORCE=(QD*QD/32.17/A+A*YBAR)*62.4
845  I=2:GOSUB 850:IF O$<>"S" THEN I=3:GOSUB 850
846  GOTO 860
850  PRINT #I,USING "###.## ####.## ####.# ###.# ###.## ###.## ###.## ###.## ###.## ######. ####.##";D,ELWS,A,T,DM,V,VH,QUOT,SH,SFORCE,ELTH:RETURN ' print subroutine
860  IF QUOT-0.5 <=0 THEN 870 ELSE DHOLD=D
870  IF DFIN-D <= 0 THEN 890
880  D=D+DELD1:NEXT N
890  D=DHOLD:DELD3=DELD1
900  FOR N=1 TO 100:GOSUB 5000:IF JTYP=3 AND D>B THEN 1020
910  IF QUOT-0.5 < 0 THEN 930 ELSE IF QUOT-0.5 = 0 THEN 980
920  D=D+DELD3:GOTO 950
930  RATIO=QUOT/0.5:IF RATIO-0.999 < 0 THEN 940 ELSE 980
940  D=D-DELD3:DELD3=DELD3/2:D=D+DELD3
950  NEXT N
980  SH=D*CFACT+VH:SFORCE=(QD*QD/32.17/A+A*YBAR)*62.4
990  ELWS=ELEVIN+D*CFACT:ELTH=ELEVIN+SH:DCR=D
1000  I=2:GOSUB 1002:IF O$<>"S" THEN I=3:GOSUB 1002
1001  GOTO 1010
1002  PRINT#I,:PRINT #I,USING " Critical Depth Results for #####.# CFS";QD:PRINT#I,:RETURN
1010  I=2:GOSUB 850 :IF O$<>"S" THEN I=3:GOSUB 850PRINT RESULTS
1020  IF ICALC <> 3 THEN 1900 'stop
1030  '
1040  ' Compute normal depth and S-Q curve for given discharge
1050  '
1060  D=DIN:I=2:GOSUB 1070:IF O$<>"S" THEN I=3:GOSUB 1070
1065  GOTO 1100
1070  PRINT #I,:PRINT #I,:PRINT #I," Computation of Stage-Discharge Using Manning's Equation":PRINT #I,
1080  PRINT #I," Depth  Area  W.P.  Hyd.R.  Veloc.  Disch.  Vel.Head  Sp.Head  El. W.S.  El.TH."
1090  PRINT #I,"   ft. sq.ft.  ft.   ft.     fps     cfs       ft.      ft.      ft.       ft. " ' print subroutine
1093  RETURN
1095  PRINT #I,USING"###.## ####.# ###.# ###.### ##.### #####.##  ###.###  ###.### #####.## ####.##";D,A,WP,R,VEL,Q,VELHD,SH,ELWS,ELTH:RETURN ' print subroutine
1100  IF SL <=0 THEN 1110 ELSE 1120
1110  PRINT USING "STOP   SL = ##.#####   DIN = ####.### ft";SL,DIN:GOTO 1900 'stop
1120  IF DIN <=0 THEN 1110
1130  DELD3=DELD1:ROOT2=SQR(SL)
1140  FOR N=1 TO 100:GOSUB 5000:IF JTYP=3 AND D>B THEN 1900
1150  VEL=(1.486/RCN)*(R^0.6667)*ROOT2:Q=VEL*A:VELHD=VEL^2/64.32
1160  ELWS=ELEVIN+D*CFACT:ELTH=ELWS+VELHD:SH=D*CFACT+VELHD
1170  IF QD-Q < 0 THEN 1180 ELSE IF QD-Q = 0 THEN 1250 ELSE GOTO 1220
1180  RATIO=Q/QD
1190  IF 1.001-RATIO < 0 THEN 1200 ELSE GOTO 1250
1200  D=D-DELD3:DELD3=DELD3/2:D=D+DELD3:GOTO 1240
1210  '
1220  I=2:GOSUB 1095:IF O$<>"S" THEN I=3:GOSUB 1095
1230  D=D+DELD3
1240  NEXT N
1250  DEPN=D:I=2:GOSUB 1095:GOSUB 1254:IF O$<>"S" THEN I=3:GOSUB 1095:GOSUB 1254
1253  GOTO 1255
1254  PRINT#I,:PRINT #I,USING" Normal Depth = ###.## ft.  Computed Discharge = #####.## CFS";DEPN,Q:RETURN
1255  GOTO 1900
1260  '
1270  ' Compute S-Q curve data for given range of depth or for given normal depth
1280  '
1300  D=DIN:PRINT
1310  GOSUB 1070
1320  IF SL <=0 THEN GOTO 1110
1330  IF DIN <= 0 THEN GOTO 1110
1340  DELD3=DELD1:ROOT2=SQR(SL)
1350  FOR N=1 TO 100:GOSUB 5000:IF JTYP=3 AND D>B THEN 1900
1360  VEL=(1.486/RCN)*(R^0.6667)*ROOT2:Q=VEL*A:VELHD=VEL^2/64.32
1370  ELWS=ELEVIN+D*CFACT:ELTH=ELWS+VELHD:SH=D*CFACT+VELHD
1380  IF DFIN-D < 0 THEN 1390 ELSE IF DFIN-D = 0 THEN 1420 ELSE 1400
1390  D=DFIN:GOTO 1410
1400  I=2:GOSUB 1095:IF O$<>"S" THEN I=3:GOSUB 1095
1410  D=D+DELD1:NEXT N
1420  DEPN=D:I=2:GOSUB 1095:GOSUB 1254:IF O$<>"S" THEN I=3:GOSUB 1095:GOSUB 1254
1450  IF ICALC <> 5 THEN GOTO 1900
1460  '
1470  ' Compute Discharge for Given Normal Depth.
1480  '    Then Compute Critical Depth and Specific Energy Data
1490  '
1500  QD=Q:IF SL <= 0.03 THEN 1550
1510  IF B < 10 THEN 1520 ELSE 1540
1520  DFIN=B:GOTO 1550
1530  '
1540  DFIN=10
1550  IF DELD1 < 0.25 THEN 1560 ELSE 1570
1560  DELD1=0.25
1570  GOTO  750
1580  '
1590  'Compute Water Surface Profile for Given Discharge and Depth Conditions
1600  '
1610  D=DST:ILINES=50:I=2:GOSUB 1620:IF O$<>"S" THEN I=3:GOSUB 1620
1615  GOTO 1670
1620  PRINT #I,:PRINT #I,"           Computation of Water Surface Profile"
1630  PRINT #I,USING"            for Discharge of #####.## cfs";QD
1640  PRINT #I," Station   Invert  Depth    W.S.   Veloc.  Vel.Head   Elev.   Del.Dist   Total"
1650  PRINT #I,"           Elev.           Elev.                       T.H.            Distance"
1660  PRINT #I,"            ft.     ft.     ft.     fps       ft.      ft.      ft.       ft. " ' print subroutine
1662  RETURN
1665  PRINT #I,USING"######.## ####.## ###.### ####.## ####.## #####.### #####.### #####.## ######.#";STAIN,ELEVIN,D1,ELEVWS,V,VH,ELEVTH,DDIST,TDIST
1666  RETURN
1667  PRINT #I,USING"######.## ####.## ###.### ####.## ####.## #####.### #####.### #####.## ######.#";STAT,ELEVB,D2,ELEVWS,V,VH,ELEVTH,DDIST,TDIST:RETURN
1670  IF DST <= 0 THEN 1680 ELSE 1690
1680  PRINT USING " STOP...DST = ####.### ft";DST
1690  CHECK=ABS(DFIN-DST):NN=CHECK/DELD2:ICOUNT=1:TDIST=0:DDIST=0
1700  GOSUB 5000:IF JTYP=3 AND D>B THEN 1900
1710  ELEVWS=ELEVIN+D*CFACT:ELEVTH=ELEVWS+VH:SH=D*CFACT+VH
1720  SF=((RCN^2)*(V^2))/(2.2082*(R^1.3333)):SF1=SF:H1=SH:D1=D
1730  I=2:GOSUB 1665:IF O$<>"S" THEN I=3:GOSUB 1665
1740  IF DST-DFIN <0 THEN 1760 ELSE IF DST-DFIN = 0 THEN 1890
1750  DELD2=-DELD2
1760  D=D+DELD2
1770  FOR N=1 TO 100:GOSUB 5000:IF JTYP=3 AND D>B THEN 1900
1780  SH=D*CFACT+VH:SF=((RCN^2)*(V^2))/(2.2082*(R^1.3333))
1790  SF2=SF:H2=SH:D2=D:SFAVG=(SF1+SF2)/2
1800  DDIST=(H2-H1)/(SL-SFAVG):TDIST=TDIST+DDIST:STAT=STAIN-TDIST
1810  ELEVB=ELEVIN-(SL*TDIST):ELEVWS=ELEVB+D2*CFACT:ELEVTH=ELEVB+H2
1820  I=2:GOSUB 1667:IF O$<>"S" THEN I=3:GOSUB 1667
1830  ICOUNT=ICOUNT+1:SF1=SF2:H1=H2:D1=D2:D=D+DELD2
1840  IF NN-N <0 THEN 1880
1850  IF ICOUNT-ILINES <0 THEN GOTO 1870
1860  PRINT:PRINT:GOSUB 1620:ILINES=ILINES+50
1870  IF D <= 0 THEN PRINT "Depth is approaching zero.":GOTO 1900
1872  NEXT N
1880  '
1890  I=2:GOSUB 1892:IF O$<>"S" THEN I=3:GOSUB 1892
1891  GOTO 1900
1892  PRINT #I,USING " Flow is at or near the depth DFIN = #####.### ft";DFIN:RETURN
1900  PRINT:PRINT " End of Problem.   Start new Problem" :PRINT:PRINT
1905  I=3:IF O$="S" THEN 1910 ELSE PRINT #I,:PRINT #I," End of Problem":PRINT #I,CHR$(12) 'Formfeed
1910  PRINT "Press RETURN to continue ":INPUT W$ 'begin new problem
1950  IF FILE$ <> "S" THEN GOTO 40 ELSE GOTO 10
2000  PRINT "End of AHD-2 Program......Thank You." :PRINT:GOTO 5330
5000  '
5010  '
5020  'SUBROUTINE COMPUT
5030  '
5040  '  Subroutine COMPUT is for computing area factors for three different
5050  '  Cross-Sections.
5060  '
5070  IF JTYP =1 THEN 5080 ELSE IF JTYP = 2 THEN 5090 ELSE GOTO 5250
5075  ' Trapezoidal
5080  A=B*D+Z*D*D:WP=B+2*D*ROOT1:YBAR=D*(0.5+Z*D/B/3)/(1+Z/B*D):GOTO 5230
5085  ' Culvert inverts
5086  ' Area and W.P. calc's for culvert invert were modified to calculate
5087  ' for sloping sidewalls.  1/85  R.G.Allen
5090  IF B < 6 THEN 5100 ELSE 5200
5100  IF D <= 0.25 THEN 5110 ELSE 5120
5110  A=(B-1.667)*D+2*D*D:WP=(B-1.667)+4.472*D
5111  YBAR=D*(0.5+D/3*(2/(B-1.667)))/(1+2/(B-1.667)*D) 'centroid
5112  GOTO 5230
5118  '   Following constant changed from .0592 to 1.12    1/85
5120  A=B*D+Z*D*D-0.2917:WP=B+1.12+2*(D-0.25)*ROOT1
5121  DA=D-0.25:YBAR= (DA*(0.5+DA/3*(Z/(B+2*Z*0.25)))/(1+Z/(B+2*Z*0.25)*DA)*((B+2*Z*0.25)*DA+DA*DA*Z) + ((B-1.667)*0.25+0.125)*(0.25*(0.5+2/(B-1.667)*0.25/3)/(1+2/(B-1.667)*0.25)) )/A 'centroid
5122  GOTO 5230
5200  IF D <= 0.33 THEN 5210 ELSE 5220
5210  A=(B-2.3333)*D+2*D*D:WP=(B-2.3333)+4.472*D
5211  YBAR=D*(0.5+D/3*(2/(B-2.333)))/(1+2/(B-2.333)*D) 'centroid
5212  GOTO 5230
5218  '   Following constant changed from .0783 to 1.49    1/85
5220  A=B*D+Z*D*D-0.5556:WP=B+1.49+2*(D-0.333)*ROOT1
5221  DA=D-0.33:YBAR= (DA*(0.5+DA/3*(Z/(B+2*Z*0.33)))/(1+Z/(B+2*Z*0.33)*DA)*((B+2*Z*0.33)*DA+DA*DA*Z) + ((B-2.333)*0.33+0.222)*(0.33*(0.5+2/(B-2.333)*0.33/3)/(1+2/(B-2.333)*0.33)) )/A 'centroid
5230  '
5240  R=A/WP:T=B+2*Z*D:DM=A/T:V=QD/A:VH=V^2/64.32:QUOT=VH/DM:GOTO 5320
5250  ' Circular cross-sections    R.G.Allen 1/85
5255  IF D>B THEN I=2:GOSUB 5257:IF O$<>"S" THEN I=3:GOSUB 5257
5256  GOTO 5258
5257  PRINT #I,USING" Depth ###.## exceeds diameter ###.## ...Quitting";D,B:RETURN
5258  IF D>B THEN GOTO 5320
5260  PI=3.14159:ARG=(B-2*D)/B:THETA=2*PI+2*(ATN(ARG/SQR(-ARG*ARG+1))-1.5708)
5270  A=((2*PI - THETA)+SIN(THETA))/8 * B^2:WP=(2*PI - THETA) * B/2
5280  R=A/WP:T=SIN(THETA/2)*B:DM=A/T:V=QD/A:VH=V^2/64.32:IF DM>D THEN DM=D
5281  IF DM<-D THEN DM=D
5282  QUOT=VH/DM
5285  ALPHA=(2*PI - THETA)/2:YR=(B*SIN(ALPHA)/3*(B/2)*(B/2) - T/3*(B/2-D)*(B/2-D))/A:YBAR=YR+D-B/2 'centroid of circular section
5320  RETURN
5330  CLOSE:END
6000  '
